#-----------------------------------------------------------------------------
# One Pose Per Frame
# for Semidieu
# Copyright @ 2004, David G. Drumright (ockham)
#-----------------------------------------------------------------------------

from Tkinter import *
import tkFileDialog
import poser
import sys
import os
scene = poser.Scene()
BasePathUncut=poser.AppLocation()
BasePath=BasePathUncut[:(-len('poser.exe'))]
PZ2Path=os.path.abspath(BasePath+'/runtime/libraries/pose/')

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("One pose for each frame.")
        self.BaseName=''

        self.StatusEntry = Entry(self.master,width=40)
        self.StatusEntry.grid(row=0,column=0,columnspan=4)
        self.StatusEntry.insert(0,"First, hit Name to set a base folder and name.")

        # Go/nogo buttons.
        self.buttonName = Button(self.master, text="Name", command=self.HandleName)
        self.buttonName.grid(row=3, column=0)

        self.buttonGo = Button(self.master, text="Go", command=self.HandleGo)
        self.buttonGo.grid(row=3, column=1)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=3, column=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -
    def HandleName(self):
        fn=tkFileDialog.asksaveasfilename(initialfile=PZ2Path, filetypes=[("Pose files", "*.PZ2 *.pz2")] )

        if not fn:
            self.ShowStatus("No name selected. Try again.")
            return 0

        FullFileName=os.path.normpath(fn)
        # Get base name for title
        base,ext=os.path.splitext(fn)
        self.BaseName=os.path.normpath(base)


        self.ShowStatus("Now hit Go to form the PZ2 files.")

    # - - - - - - - - - - - - - - - - - -
    def ShowStatus(self,S): # Just saving repetition
        self.StatusEntry.delete(0,END)
        self.StatusEntry.insert(0,S)
        self.StatusEntry.update_idletasks()

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents(1)
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleGo(self):
        # Action here
        for F in range(scene.NumFrames()):
            scene.SetFrame(F)
            self.ShowStatus("Saving frame %d" % (F+1))
            FullName="%s_%.3d.PZ2" % (self.BaseName,(F+1))
            scene.SaveLibraryPose(FullName)

        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
